#!/usr/bin/perl
# $Id: psmisc.pm 4098 2008-04-30 18:29:07Z pro $ $URL: svn://svn.setun.net/search/trunk/lib/psmisc.pm $

=copyright
PRO-search shared library
Copyright (C) 2003-2007 Oleg Alexeenkov http://pro.setun.net/search/ proler@gmail.com icq#89088275

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA,
or download it from http://www.gnu.org/licenses/gpl.html
=cut

#  print "Content-type: text/html\n\n" if defined($ENV{'SERVER_PORT'}); # for web dev debug
#    print "misc execute " , $mi++;
#=pac
package psmisc;
use locale;
use strict;
use Data::Dumper;    #dev only
$Data::Dumper::Sortkeys = 1;
#use vars qw( %config %work %stat %static $param %processor %program %out );    #%human,
#our ( @ISA, @EXPORT, @EXPORT_OK );
#our ( @ISA, @EXPORT, @EXPORT_OK );
use vars qw( @ISA @EXPORT @EXPORT_OK );
require Exporter;
#our
#@psmisc::
@ISA = qw(Exporter);
#our
#@psmisc::
@EXPORT = qw(
  get_params_one
  get_params
  encode_url
  encode_url_link
  decode_url
  printlog
  printprog
  openproc
  state
  hconfig
  html_chars
  name_to_ip
  normalize_ip
  ip_to_name
  counter
  timer
  join_url
  split_url
  full_host
  cp_trans
  utf_trans
  to_utf_trans
  cp_trans_hash
  cp_detect_trans
  lang
  min
  max
  alarmed
  mkdir_rec
  open_out_file
  close_out_file
  sleeper
  mysleep
  check_int
  shuffle
  config_reload
  conf
  http_get
  http_get_code
  loadlist
  shelldata
  %work %config %stat %static $param
  %processor %program
  );    #%human %out
#  flush
our ( %config, %work, %stat, %static, $param, %processor, %program, $root_path, %human );    #%human, %out,
use Socket;
use Time::HiRes qw(time);
no warnings qw(uninitialized);
#my %human;
#sub conf_once {
sub config_init {
  return if $static{'lib_init_psmisc'}{ $ENV{'SCRIPT_FILENAME'} }++;
  my ($param) = @_;
  #  print "  psmisc::config_init;";
  #caller_trace(10);
  conf(
    sub {
#print "  psmisc::config_init:sub;";
#A                                                              |                                                            YA  E   a                                                              |                                                            ya  e   |-ukr------------------|
      $config{'trans'}{'cp1251'} ||=
"\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xA8\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF\xB8\xB2\xB3\xAF\xBF\xAA\xBA";
      $config{'trans'}{'koi8-r'} ||=
"\xE1\xE2\xF7\xE7\xE4\xE5\xF6\xFA\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF2\xF3\xF4\xF5\xE6\xE8\xE3\xFE\xFB\xFD\xFF\xF9\xF8\xFC\xE0\xF1\xB3\xC1\xC2\xD7\xC7\xC4\xC5\xD6\xDA\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD2\xD3\xD4\xD5\xC6\xC8\xC3\xDE\xDB\xDD\xDF\xD9\xD8\xDC\xC0\xD1\xA3\xB6\xA6\xB7\xA7\xB4\xA4";
      $config{'trans'}{'iso8859-5'} ||=
"\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xA1\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF1\xA6\xF6\xA7\xF7\xA4\xF4";
      $config{'trans'}{'cp866'} ||=
"\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xF0\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF1\xF6\xF7\xF8\xF9\xF4\xF5";
      $config{'trans'}{'utf-8'} ||= "\xD0\xD1";    #JUST TRICK for autodetect
      #$config{'trans_up'}{$_} = (split//, $config{'trans'}{$_})[0..32] for keys %{$config{'trans'}};
      $config{'trans_up'}{$_}   = substr( $config{'trans'}{$_}, 0,  33 ),
        $config{'trans_lo'}{$_} = substr( $config{'trans'}{$_}, 33, 33 ),
        #     print "$config{'trans_up'}{$_} - $config{'trans_lo'}{$_}\n"
        for keys %{ $config{'trans'} };

=with 50% UPPER case
# cp detect with cp_learn_symbols=10; from 28691 bytes text
  $config{'trans_detect'}{'cp1251'}	||= '\xCE\xEE\xC0\xE0\xE5\xC5\xD2\xF2\xE8\xC8';	#  [] = [];	stat:[CE]=658; [EE]=658; [C0]=578; [E0]=578; [E5]=503; [C5]=503; [D2]=434; [F2]=434; [E8]=422; [C8]=422; 
  $config{'trans_detect'}{'cp866'}	||= '\xAE\x8E\x80\xA0\xA5\x85\x92\xE2\xA8\x88';	#  [R___:'_] = [];	stat:[AE]=658; [8E]=658; [80]=578; [A0]=578; [A5]=503; [85]=503; [92]=434; [E2]=434; [A8]=422; [88]=422; 
  $config{'trans_detect'}{'koi8-r'}	||= '\xCF\xEF\xC1\xE1\xC5\xE5\xD4\xF4\xC9\xE9';	#  [⒨] = [];	stat:[CF]=658; [EF]=658; [C1]=578; [E1]=578; [C5]=503; [E5]=503; [D4]=434; [F4]=434; [C9]=422; [E9]=422; 
  $config{'trans_detect'}{'utf-8'}	||= '\xD0\xD1\x9E\xBE\xB0\x90\x95\xB5\xA2\x82';	#  [___'] = [_ǯめ];	stat:[D0]=10542; [D1]=1934; [9E]=658; _[BE]=658; [B0]=578; [90]=578; [95]=503; [B5]=503; [A2]=434; [82]=434; 
#  $config{'trans_detect'}{'iso8859-5'}	||= '\xDE\xBE\xD0\xB0\xB5\xD5\xC2\xE2\xB8\xD8';	#  [_ǂ㡁] = [];	stat:[DE]=658; [BE]=658; [D0]=578; [B0]=578; [B5]=503; [D5]=503; [C2]=434; [E2]=434; [B8]=422; [D8]=422; 
=cut

      # cp detect with cp_learn_symbols=20; from 14344 bytes text
      $config{'trans_detect'}{'cp1251'} ||= '\xEE\xE0\xE5\xF2\xE8\xED\xF1\xF0\xE2\xEA\xEB\xEF\xE4\xFC\xEC\xE7\xF3\xE1\xFB\xF7'
        ; #  [] = [];	stat:[EE]=649; [E0]=573; [E5]=489; [F2]=425; [E8]=416; [ED]=410; [F1]=379; [F0]=296; [E2]=269; [EA]=256; [EB]=221; [EF]=194; [E4]=174; [FC]=156; [EC]=153; [E7]=152; [F3]=141; [E1]=109; [FB]=108; [F7]=100;
      $config{'trans_detect'}{'cp866'} ||= '\xAE\xA0\xA5\xE2\xA8\xAD\xE1\xE0\xA2\xAA\xAB\xAF\xA4\xEC\xAC\xA7\xE3\xA1\xEB\xE7'
        ; #  [R_-<֋] = [];	stat:[AE]=649; [A0]=573; [A5]=489; [E2]=425; [A8]=416; [AD]=410; [E1]=379; [E0]=296; [A2]=269; [AA]=256; [AB]=221; [AF]=194; [A4]=174; [EC]=156; [AC]=153; [A7]=152; [E3]=141; [A1]=109; [EB]=108; [E7]=100;
      $config{'trans_detect'}{'koi8-r'} ||= '\xCF\xC1\xC5\xD4\xC9\xCE\xD3\xD2\xD7\xCB\xCC\xD0\xC4\xD8\xCD\xDA\xD5\xC2\xD9\xDE'
        ; #  [⨭ࢪ쬧] = [];	stat:[CF]=649; [C1]=573; [C5]=489; [D4]=425; [C9]=416; [CE]=410; [D3]=379; [D2]=296; [D7]=269; [CB]=256; [CC]=221; [D0]=194; [C4]=174; [D8]=156; [CD]=153; [DA]=152; [D5]=141; [C2]=109; [D9]=108; [DE]=100;
      $config{'trans_detect'}{'utf-8'} ||= '\xD0\xD1\xBE\xB0\xB5\x82\xB8\xBD\x81\x80\xB2\xBA\xBB\xBF\xB4\x8C\xBC\xB7\x83\xB1'
        ; #  [_ǂ'____>____+] = [_ǂ__>__+];	stat:[D0]=4352; [D1]=1894; _[BE]=649; [B0]=573; [B5]=489; [82]=425; [B8]=416; _[BD]=410; [81]=379; [80]=296; _[B2]=269; [BA]=256; >[BB]=221; [BF]=194; _[B4]=174; [8C]=156; _[BC]=153; [B7]=152; [83]=141; +[B1]=109;
#  $config{'trans_detect'}{'iso8859-5'}	||= '\xDE\xD0\xD5\xE2\xD8\xDD\xE1\xE0\xD2\xDA\xDB\xDF\xD4\xEC\xDC\xD7\xE3\xD1\xEB\xE7';	#  [逞] = [];	stat:[DE]=649; [D0]=573; [D5]=489; [E2]=425; [D8]=416; [DD]=410; [E1]=379; [E0]=296; [D2]=269; [DA]=256; [DB]=221; [DF]=194; [D4]=174; [EC]=156; [DC]=153; [D7]=152; [E3]=141; [D1]=109; [EB]=108; [E7]=100;
#  $config{'trans_detect'}{'cp1251'}	||= "\xE0\xC0\xEE\xCE"; # 
#  $config{'trans_detect'}{'cp866'}	||= "\xA0\x80\xAE\x8E";
#  $config{'trans_detect'}{'koi8-r'}	||= "\xC1\xE1\xCF\xEF";
## $config{'trans_detect'}{'iso8859-5'}	||= "\xD0\xB0\xDE\xBE";
      #  $config{'trans_detect'}{'utf-8'}	||= "\xD0\xD1";
      #$config{'trans_name'}{'cp1251'} ||= 'cp1251';
      $config{'trans_name'}{'win1251'}      ||= 'cp1251';
      $config{'trans_name'}{'windows1251'}  ||= 'cp1251';
      $config{'trans_name'}{'windows-1251'} ||= 'cp1251';
      $config{'trans_name'}{'win'}          ||= 'cp1251';
      $config{'trans_name'}{'1251'}         ||= 'cp1251';
      # $config{'trans_name'}{'koi8-r'} ||= 'koi8-r';
      $config{'trans_name'}{'koi8r'} ||= 'koi8-r';
      $config{'trans_name'}{'koi8'}  ||= 'koi8-r';
      $config{'trans_name'}{'koi'}   ||= 'koi8-r';
      # $config{'trans_name'}{'iso8859-5'} ||='iso8859-5';
      $config{'trans_name'}{'iso88595'} ||= 'iso8859-5';
      $config{'trans_name'}{'iso8859'}  ||= 'iso8859-5';
      $config{'trans_name'}{'iso'}      ||= 'iso8859-5';
      #$config{'trans_name'}{'cp866'} ||='cp866';
      $config{'trans_name'}{'866'} ||= 'cp866';
      $config{'trans_name'}{'dos'} ||= 'cp866';
      #$config{'trans_name'}{'utf-8'} ||= 'utf-8';
      $config{'trans_name'}{'utf8'}  ||= 'utf-8';
      $config{'trans_name'}{'utf'}   ||= 'utf-8';
      $config{'kilo'}                ||= 8;                                                      # 5000k 6000k 7000k >8<m 9m 10m
      $config{'lng'}{'en'}{'months'} ||= [qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec)];
      $config{'lng'}{'ru'}{'months'} ||= [qw(           )];
      @{ $config{'lng'}{$_}{'month_table'} }{ @{ $config{'lng'}{$_}{'months'} or [] } } = ( 0 .. 11 )
        for keys %{ $config{'lng'} };
      #   @{ $config{'lng'}{''}{'month_table'} }{ @{ $config{'lng'}{''}{'months'} } } = ( 0 .. 11 )  ;
      $config{'lng'}{'en'}{'wdays'} ||= [qw(Sun Mon Tue Wed Thu Fri Sat)];
      $config{'log_screen'}         ||= 1;
      $config{'log_default'}        ||= $config{'root_path'} . 'log.log';
      #$config{'log_all'}     ||= '#book.log';
      #$config{'log_all'}     ||= '1';
      $config{'encode_url_file_mask'} ||= '[^a-zA-Z0-9\-.()_]';                                  #url = '[^a-zA-Z0-9\-.()_!,]';
    },
    1000,
  );
}

sub get_params_one {    # p=x,p=y,p=z => p=x,p1=y,p2=z ; p>=z => p=z, p_mode='>'; p => p; -p => -p=1;
  my $ret = shift || {};
  for (@_) {
    local %_;           #
    #    ( $_{'k'}, $_{'v'} )
    @_{ 'k', 'v' } = (/^([^=]+=?)=(.+)$/) ? ( $1, $2 ) : ( ( (/^([^=]*)=?$/)[0] ), ( /^-/ ? 1 : '' ) );
    #    $_{'v'} =~ s/^NUL$//;  # PERL RULEZ # SORRY # 8-) #
    $_{$_} =~ tr/+/ /, $_{$_} =~ s/%([a-fA-F0-9]{2})/pack('C', hex($1))/eg for qw(k v);
    $ret->{ $1 . '_mode' . $2 } .= $3 if $_{'k'} =~ s/^(.+?)(\d*)([=!><~@]+)$/$1$2/;
    $_{'k'} =~ s/(\d*)$/($1 < 100 ? $1 + 1 : last)/e while ( defined( $ret->{ $_{'k'} } ) );
    $ret->{ $_{'k'} } = $_{'v'};    #lc can be here
  }
  return wantarray ? %$ret : $ret;
}

sub get_params {                    #v6
  my ( $par_string, $delim ) = @_;
  $delim ||= '&';
  local %_;
  read( STDIN, local $_ = '', $ENV{'CONTENT_LENGTH'} ) if !$par_string and $ENV{'CONTENT_LENGTH'};

=cu
------------jCZJhSDkEEg0Avf4h2hejC
Content-Disposition: form-data; name="n1"

ertyeryery
------------jCZJhSDkEEg0Avf4h2hejC
Content-Disposition: form-data; name="n2"

ryertytry
------------jCZJhSDkEEg0Avf4h2hejC
Content-Disposition: form-data; name="q"

ertyeryery
------------jCZJhSDkEEg0Avf4h2hejC--    
=cut

  %_ = (
    %_,
    $par_string
    ? ( get_params_one( undef, split( $delim, $par_string ) ) )
    : (
      get_params_one( undef, @ARGV ), map { get_params_one( undef, split $delim, $_ ) } split( /;\s*/, $ENV{'HTTP_COOKIE'} ),
      $ENV{'QUERY_STRING'}, $_
    )
  );
  return wantarray ? %_ : \%_;
}

sub encode_url {    #v5
  my ( $str, $mask ) = @_;
  return $str if defined $mask and !$mask;
  $mask ||= '[^a-zA-Z0-9\-.()_!,]';
  #  return join( '+', map { s/$mask/'%'.sprintf('%02X', ord($&))/ge; $_ } split( /\x20/, $str ) );
  return join '+', map { s/($mask)/sprintf'%%%02X',ord $1/ge; $_ } split /\x20/, $str;
}

sub encode_url_link {
  #v5
  my ( $str, $mask ) = @_;
  return $str if defined $mask and !$mask;
  return $str if $str =~ /^(magnet|file):/i;
  #fixed?
  return $str if $config{'client_ie'};
  $mask ||= '[^a-zA-Z0-9\-.()_\:@\/!,]';
  $str =~ s/$mask/'%'.sprintf('%2X', ord($&))/ge;
  return $str;
}

sub decode_url {    #v1
  my ($str) = @_;
  $str =~ s/%([a-fA-F0-9]{2})/pack('C', hex($1))/eg;
  return $str;
}
#all def fac =
# u   u   u  0
# u   1   u  1
# u   0   u  0
# u   1   0  0
# u   *   1  1
# 0   *   *  0
# 1   *   *  1
sub printlog {    #v4  # todo cache open logfiles ?
  #  print "[devlog][fac:$_[0]=".$config{ 'log_' . $_[0]}."][][log_screen=$config{'log_screen'} ]\n",Dumper (\%config );
  return if defined $config{ 'log_' . $_[0] } and !$config{ 'log_' . $_[0] } and !$config{'log_all'};
  # my $file = ( $config{'log_all'} or ( defined $config{ 'log_' . $_[0] } ? $config{ 'log_' . $_[0] } : '' ) );
  my $file = ( (
      defined $config{'log_all'}
      ? $config{'log_all'}
      : ( defined $config{ 'log_' . $_[0] } ? $config{ 'log_' . $_[0] } : $config{'log_default'} )
    )
  );
  my $noscreen;
  for ( 0 .. 1 ) {
    $noscreen = 1 if $file =~ s/^[\-_]// or !$file;
    $noscreen = 0 if $file =~ s/^[+\#]//;
    $file = $config{'log_default'}, next if $file eq '1';
    last;
  }
  $file = undef if $file eq '1';
  my $html = !$file and ( ( $config{'view'} eq 'html' ) or ( $config{'view'} =~ /http/i ) );
  my $xml = $config{'view'} eq 'xml';
  my @string = (
    ( $xml  ? '<debug><![CDATA['    : () ),
    ( $html ? '<div class="debug">' : () ),
    (
      ( ( $html or $xml ) and !$file ) ? ()
      : (
        human( 'date_time', ), ( $config{'log_micro'} ? human('micro_time') : () ), ( $config{'log_pid'} ? (" [$$]") : () ),
      )
    ), (
      $config{'log_caller'}
      ? ( ' [', join( ',', grep $_, map ( ( caller($_) )[ 2 .. 3 ], ( 0 .. $config{'log_caller'} - 1 ) ) ), ']' )
      : ()
    ),
    ' ',
    join( ' ', @_ ),
    (),
    ( $html ? '</div>'      : () ),
    ( $xml  ? ']]></debug>' : () ),
    ("\n")
  );
#  print "[devlog][fac:$_[0]=".$config{ 'log_' . $_[0]}."][file=$file][log_screen=$config{'log_screen'} log_default=$config{'log_default'} noscreen=$noscreen html=$html xml=$xml]\n" ;
  if ( @_ and $file and open( LOG, '>>', $file ) ) {
    print LOG@string;
    close(LOG);
  }
  print @string if @_ and $config{'log_screen'} and !$noscreen;
  #  state(@_);
  flush() if $config{'log_flush'};
  return @_;
}

sub openproc {
  my ($proc) = @_;
  printlog( 'dbg', 'run ext:', $proc );
  my $handle;
  return $handle if open( $handle, $proc );
  return 0;
}

sub printprog {    #v1
  my ( $proc, $nologbody, $handler ) = @_;
  return unless $proc;
  my $ret;
  my $tim = timer();
  printlog( 'dbg', "Starting [$proc]:" );
  system($proc), return if $nologbody;
  my $h = openproc("$proc $config{'stderr_redirect'}|") or return $ret = 1;
  while (<$h>) {
    s/\s*[\x0A\x0D]*$//;
    next unless $_;
    printlog( 'dbg', $_ );
    $ret = 2, last if $handler and $handler->($_);
  }
  close($h);
  printlog( 'dbg', 'prog done per', human( 'time_period', $tim->() ) );
  return $ret;
}

sub state {
  $work{'$0'} ||= $0;
  $0 = $config{'state_prefix'} . join ' ', @_;
}

sub hconfig {
  my $par = shift;
  #  printlog('hc0', $par,@_);
  #  printlog('hc1', $_, $par),
  return $config{'fine'}{$_}{$par} for grep { defined( $config{'fine'}{$_}{$par} ) } @_;
  #  printlog('hc2', $par),
  return $config{$par};
}
$human{'date'} ||= sub {    #v1
  my ( $day_of_month, $month, $year ) = ( localtime( ( $_[0] or time() ) ) )[ 3 .. 5 ];
  return sprintf( '%04d' . ( ( ( $_[1] or '/' ) . '%02d' ) x 2 ), $year + 1900, $month + 1, $day_of_month );
};
$human{'time'} ||= sub {
  return sprintf( join( ( $_[1] or ':' ), ( ("%02d") x 3 ) ), ( reverse( ( localtime( ( $_[0] or time() ) ) )[ 0 .. 2 ] ) ) );
};
$human{'date_time'} ||=
  sub { return human( 'date', ( $_[0] or time() ), $_[2] ) . ( $_[1] or '-' ) . human( 'time', ( $_[0] or time() ), $_[3] ); };
$human{'float'} ||= sub {    #v1
  return ( $_[0] < 8 and $_[0] - int( $_[0] ) )
    ? sprintf( '%.' . ( $_[0] < 1 ? 3 : ( $_[0] < 3 ? 2 : 1 ) ) . 'f', $_[0] )
    : int( $_[0] );
};
$human{'micro_time'} ||= sub {
  my $now = time();
  ( $now = human( 'float', abs( int($now) - $now ) ) ) =~ s/^0//;
  return ( $now or '' );
};
$human{'rfc822_date_time'} ||= sub {
  my ( $day_of_month, $month, $year, $wday ) = ( localtime( ( $_[0] or time() ) ) )[ 3 .. 6 ];
  return sprintf( $config{'lng'}{'en'}{'wdays'}[$wday] . ', %02d ' . $config{'lng'}{'en'}{'months'}[$month] . ' %02d',
    $day_of_month, $year + 1900 )
    . ' '
    . $human{'time'}->( ( $_[0] or time() ) )
    . ' +0300';
};
$human{'size'} ||= sub {
  my ( $size, $sp, $kilo ) = @_;
  $sp ||= ( $ENV{'SERVER_PORT'} ? '&nbsp;' : ' ' );
  $kilo ||= $config{'kilo'} || 8;
  return int( $size / 1099511627776 ) . $sp . 'TB' if ( $size >= $kilo * 1099511627776 );
  return int( $size / 1073741824 ) . $sp . 'GB'    if ( $size >= $kilo * 1073741824 );
  return int( $size / 1048576 ) . $sp . 'MB'       if ( $size >= $kilo * 1048576 );
  return int( $size / 1024 ) . $sp . 'KB'          if ( $size >= $kilo * 1024 );
  return human( 'float', $size ) . $sp . 'B' if ( $size > 0 );
  return $size;
};
$human{'number_k'} ||= sub {
  local $_ = $_[0];
  $_ *= 1024          if ( $_ =~ s/kb?$//gi );
  $_ *= 1048576       if ( $_ =~ s/mb?$//gi );
  $_ *= 1073741824    if ( $_ =~ s/gb?$//gi );
  $_ *= 1099511627776 if ( $_ =~ s/tb?$//gi );
  return $_;
};
$human{'procent'} ||= sub {    #v1
  return sprintf( '%' . ( $_[0] < 10 ? '.3f' : 'd' ), $_[0] ) . '%';
};
$human{'time_period'} ||= sub {    #v0
  my ( $tim, $delim, $sign ) = @_;
  $sign = '-', $tim = -$tim if $tim < 0;
  #print("tpern[", $tim, ']'),
  return '' if $tim == 0 or $tim > 1000000000;
  #print("tperf[", $tim, ']'),
  return ( $sign . human( 'float', $tim ) . $delim . "s" ) if $tim < 60;
  $tim = int( $tim / 60 );
  return ( $sign . $tim . $delim . "m" ) if $tim < 60;
  $tim = int( $tim / 60 );
  return ( $sign . $tim . $delim . "h" ) if $tim < 24;
  $tim = int( $tim / 24 );
  return ( $sign . $tim . $delim . "d" ) if $tim < 31;
  $tim = int( $tim / 31 );
  return ( $sign . $tim . $delim . "M" ) if $tim < 12;
  $tim = int( $tim / 12 );
  return ( $sign . $tim . $delim . "Y" );
};
$human{'number'} ||= sub {    #v0 #FIXIT
  #  return $_ = reverse( join( ' ', split( /(\d{3})/, reverse $_[0] ) ) );
  #  local $_ = reverse( join( ' ', split( /(\d{3})/, reverse $_[0] ) ) );
  #  return $_;
  #return reverse( join( ' ', grep {length $_} split( /(\d{3})/, reverse $_[0] ) ) )
  return local $_ = reverse( join( ' ', grep { length $_ } split( /(\d{3})/, reverse $_[0] ) ) );
};

sub html_chars {
  local $_ = $_[0];
  $$_ =~ s/\&/\&amp\;/g;
  $$_ =~ s/\</\&lt\;/g;
  $$_ =~ s/\>/\&gt\;/g;
}
$human{'string_long'} ||= sub {
  my $maxlen = ( $_[1] or 20 );
  html_chars( \$_[0] );
  return $_[0] if length $_[0] <= $maxlen;
  my $print = substr( $_[0], 0, $maxlen );
  $print =~ s/[\xD0\xD1]$//;
  $_[0]  =~ s/\"/&quot;/g;
  return "<span title=\"" . $_[0] . "\">$print...</span>";
};

sub human {
  my $via = shift;
  return $human{$via}->(@_) if ref $human{$via} eq 'CODE';
  return @_;
}

sub func_cache {
  my ($func) = shift;
  my $save = $func . join( ':', @_ );
  unless ( $static{'func_cache'}{$save} ) { @{ $static{'func_cache'}{$save} } = $func->(@_); }
  else                                    { }
  return wantarray ? @{ $static{'func_cache'}{$save} } : $static{'func_cache'}{$save}[0];
}

sub name_to_ip_noc {
  my ($name) = @_;
  unless ( $name =~ /^\d+\.\d+\.\d+\.\d+$/ ) {
    local $_ = ( gethostbyname($name) )[4];
    return ( $name, 1 ) unless length($_) == 4;
    $name = inet_ntoa($_);
  }
  return $name;
}

sub ip_to_name_noc {    #v1
  local $_;
  return $_[0] unless $_ = ( gethostbyname( $_[0] ) )[4];
  return inet_ntoa($_);
}
sub normalize_ip { return func_cache( \&normalize_ip_noc, @_ ); }
sub ip_to_name   { return func_cache( \&ip_to_name_noc,   @_ ); }
sub name_to_ip   { return func_cache( \&name_to_ip_noc,   @_ ); }

sub normalize_ip_noc {    #v2
  my ($ip) = @_;
  my ($err);
  ( $ip, $err ) = name_to_ip($ip);
  return $ip if $err;
  my ( $tmp, $host );
  return $ip unless $tmp = inet_aton($ip);
  return $ip unless $host = ( gethostbyaddr( $tmp, AF_INET ) )[0];
  for my $repl ( @{ $config{'ip_normalize_pre'} } ) {
    last if $host =~ /^$repl\./;
    my $thost = $host;
    $thost =~ s/^[^.]+/$repl/;
    my $pip = inet_aton($ip);
    for $thost ( ( $host =~ /\..+\./ ? ($thost) : () ), $repl . '.' . $host ) {
      next unless @_ = grep $_, ( ( gethostbyname($thost) )[ 4 .. 14 ] );
      return $thost for ( grep $_ eq $pip, @_ );
    }
  }
  return $ip unless @_ = ( gethostbyname($host) )[4];
  return $host for grep $_ eq $ip, map $_ = inet_ntoa($_), @_;
  return $ip;
}

sub counter {
  my $start = $_[0];
  return sub {
    $start = $_[1] if $_[1];
    return ( $_[0] - $start ) >= 0 ? ( $_[0] - $start ) : $start;
  };
}

sub timer {
  my ( $start, $ret ) = ( $_[0] or time() );
  return sub {
    $ret = time() - $start;
    $start = ( $_[0] or time() ) if defined( $_[0] );
    return $ret;
  };
}

sub join_url {    #v2
  return ( $_[0]->{'prot'} ? $_[0]->{'prot'} . '://' : '' )
    . ( $_[0]->{'user'} ? $_[0]->{'user'} . ( $_[0]->{'pass'} ? ':' . $_[0]->{'pass'} : '' ) . '@' : '' )
    . $_[0]->{'host'}
    . ( (
      $_[0]->{'port'}
        and ( !$static{'port2prot'}{ $_[0]->{'port'} } or ( $static{'port2prot'}{ $_[0]->{'port'} } ne $_[0]->{'prot'} ) )
    )
    ? ':'
      . $_[0]->{'port'}
    : ''
    )
    . ( $_[0]->{'dcuser'} ? '/' . $_[0]->{'dcuser'} : '' )
    . ( ( !$_[0]->{'path'} or $_[0]->{'path'} =~ /^\// ) ? '' : '/' )
    . $_[0]->{'path'}
    . ( ( ( !$_[0]->{'path'} and ( !$_[0]->{'host'} or !( $_[0]->{'name'} or $_[0]->{'ext'} ) ) ) or $_[0]->{'path'} =~ /\/$/ )
    ? ''
    : '/' )
    . $_[0]->{'name'}
    . ( $_[0]->{'ext'} ? '.' . $_[0]->{'ext'} : '' );
}

sub split_url {    #v3
  my $table = ( $_[1] or $config{'sql_tresource'} );
  local %_ = ();
  ( $_{'prot'}, $_{'host'} ) = $_[0]      =~ m|^\s*(?:(\w+)\://)?(.*)$|;
  ( $_{'host'}, $_{'path'} ) = $_{'host'} =~ m|^([^/]*)(/.*)?$|;
  ( $_{'user'}, $_{'host'} ) = $_{'host'} =~ m|^(?:(.+)@)?(.*)|;
  ( $_{'user'}, $_{'pass'} ) = $_{'user'} =~ m|^([^/:@]+):?(.*)|;
  ( $_{'host'}, $_{'port'} ) = $_{'host'} =~ m|([^/:@]+)\:?(\d*)$|;
  $_{'path'} =~ s|([^/]*)$||;
  ( $_{'name'} ) = $1;
  $_{'path'} =~ s|/*$|| if $_{'path'} ne '/';
  $_{'path'} ||= '/' if $_{'name'} or $_{'ext'};
  ( $_{'ext'} ) = ( $_{'name'} =~ s/\.([^\.]+)$// ? ($1) : ('') );
  delete $_{'port'}
    unless ( $_{'port'} and ( !$static{'port2prot'}{ $_{'port'} } or ( $static{'port2prot'}{ $_{'port'} } ne $_{'prot'} ) ) );

  if ( $_{'prot'} eq 'dchub' ) {
    #printlog   ('split_url', 1, join ':', %_);
    my $dcuser;
    ( $_{'path'} =~ s|^(/[^/]+)|| and $dcuser = $1 )
      or ($_{'path'} =~ s|^/?$||
      and $_{'name'} =~ s|(.+)||
      and $dcuser = $1
      and $_{'ext'} =~ s|(.*)||
      and $dcuser .= ( $1 ? ".$1" : '' ) );
    #printlog   ('split_url', 2, join ':', %_);
    if ( %{ $config{'sql'}{'table'}{$table}{'dcuser'} or {} } ) { $_{'dcuser'} = $dcuser; }
    else {
      ( $_{'host'} = join_url( { 'host' => $_{'host'}, 'port' => $_{'port'}, 'path' => $dcuser, } ) ) =~ s|/$||;
      delete $_{'port'};
      #printlog   ('split_url', 3, join ':', %_);
    }
  }
  delete $_{$_} for grep !length $_{$_}, keys %_;
  #printlog   ('split_url', 'R', join ':', %_);
  return wantarray ? %_ : \%_;
}

sub full_host {
  my $table = ( $_[1] or $config{'sql_tresource'} );
  return join_url( {
      ( %{ $config{'sql'}{'table'}{$table}{'user'} or {} } ? () : ( 'user' => $_[0]->{'user'} ) ),
      ( %{ $config{'sql'}{'table'}{$table}{'pass'} or {} } ? () : ( 'pass' => $_[0]->{'pass'} ) ),
      'host' => $_[0]->{'host'}, ( ( (
            $_[0]->{'port'}
              and ( !$static{'port2prot'}{ $_[0]->{'port'} } or ( $static{'port2prot'}{ $_[0]->{'port'} } ne $_[0]->{'prot'} ) )
          )
            and ( !%{ $config{'sql'}{'table'}{$table}{'port'} or {} } or ( $_[0]->{'prot'} eq 'dchub' ) )
        ) ? ( 'port' => $_[0]->{'port'} ) : ()
      ),
      ( %{ $config{'sql'}{'table'}{$table}{'dcuser'} or {} } ? () : ( 'dcuser' => $_[0]->{'dcuser'} ) ),
    }
  );
}
sub cp_normalize { return $config{'trans_name'}{ lc $_[0] } || lc $_[0]; }

sub cp_trans {    #v1
  my ( $cfrom, $cto, $string ) = @_;
  $cfrom = cp_normalize($cfrom);
  $cto   = cp_normalize($cto);
  #    printlog('dev', 'cp_trans:', $cfrom, $cto, $string);
  return $string if $cto eq $cfrom or !length($string);
  #  print('dev', 'cp_trans:', $cfrom, $cto, $string);
  #  local $_ = "$cfrom -> $cto";
  #  caller_trace();
  return utf_trans( $cto, $string ) if $cfrom eq 'utf-8' and $config{'trans'}{$cto};
  return to_utf_trans( $cfrom, $string ) if $cto eq 'utf-8' and $config{'trans'}{$cfrom};
  my $cnt;
  if ( $config{'trans'}{$cfrom} and $config{'trans'}{$cto} ) {
    ( $cfrom, $cto ) = \( $config{'trans'}{$cfrom}, $config{'trans'}{$cto} );
    eval "\$cnt = \$string =~ tr/$$cfrom/$$cto/";
  }
  #    printlog('dev', "cp_trans($_):", $string),     caller_trace()     if $cnt;
  return wantarray ? ( $string, $cnt ) : $string;
}

sub utf_trans {
  my ( $cto, $string ) = @_;
  $cto ||= $config{'cp_db'};
  $cto = cp_normalize($cto);
  return if $cto eq 'utf-8';
  my ( $cnt, $cnt2 );
  $cnt += $string =~ s/\xD0\x81/\xF0/g;     # e
  $cnt += $string =~ s/\xD1\x91/\xF1/g;     # E
  $cnt += $string =~ s/\xD0\x84/\xF4/g;     # ukr beg
  $cnt += $string =~ s/\xD1\x94/\xF5/g;
  $cnt += $string =~ s/\xD0\x86/\xF6/g;
  $cnt += $string =~ s/\xD1\x96/\xF7/g;
  $cnt += $string =~ s/\xD0\x87/\xF8/g;
  $cnt += $string =~ s/\xD1\x97/\xF9/g;     # ukr end
  $cnt += $string =~ s/\xE2\x80\x94/-/g;    # -
  $cnt += $string =~ s/\xC2\xAB/"/g;        # 
  $cnt += $string =~ s/\xC2\xBB/"/g;        # 
  $cnt += $string =~ s/\xD1\x98/j/g;        #
  $cnt += $string =~ s/\xD0\xB9/\xA9/g;     # 
  #  $cnt += $string =~ s/\xD0\xA9/\xC9/g;                           # 
  $cnt += $string =~ s/\xD0([\x90-\xBF])/chr(ord($1)-16)/eg;
  $cnt += $string =~ s/\xD1([\x80-\x8F])/chr(ord($1)+96)/eg;
  ( $string, $cnt2 ) = cp_trans( 'cp866', $cto, $string );
  $cnt += $cnt2;
  $cnt += $string =~ s/\x21\x16/\xB9/g;     # 
  return wantarray ? ( $string, $cnt ) : $string;
}

sub to_utf_trans {
  my ( $cfrom, $string ) = @_;
  $cfrom ||= $config{'cp_db'};
  $cfrom = cp_normalize($cfrom);
  return if $cfrom eq 'utf-8';
  my $cnt;
  #  $cnt += $string =~ s/\xE9/\xD0\xB9/g;                           # 
  $cnt += $string =~ s/\xAB/"/g;            # <
  $cnt += $string =~ s/\xBB/"/g;            # <
  #  print "\ndos0[$string]\n";
  ( $string, $cnt ) = cp_trans( $cfrom, 'cp866', $string );
  # print "\ndos1[$string]\n";
  $cnt += $string =~ s/([\x80-\x88\x8A-\xA8\xAA-\xAF])/"\xD0".chr(ord($1)+16)/eg;
  $cnt += $string =~ s/([\xE0-\xE8\xEA-\xEF])/"\xD1".chr(ord($1)-96)/eg;
  #  print "\ndos2[$string]\n";
  $cnt += $string =~ s/\xF0/\xD0\x81/g;     # e
  $cnt += $string =~ s/\xF1/\xD1\x91/g;     # E
  $cnt += $string =~ s/\xF4/\xD0\x84/g;     # ukr beg
  $cnt += $string =~ s/\xF5/\xD1\x94/g;
  $cnt += $string =~ s/\xF6/\xD0\x86/g;
  $cnt += $string =~ s/\xF7/\xD1\x96/g;
  $cnt += $string =~ s/\xF8/\xD0\x87/g;
  $cnt += $string =~ s/\xF9/\xD1\x97/g;     # ukr end
  #=c
  $cnt += $string =~ s/(?<!\xD0)\xB9/\x21\x16/g;    # 
  $cnt += $string =~ s/(?<!\xD0)\xA9/\xD0\xB9/g;    # 
  $cnt += $string =~ s/(?<!\xD0)\x89/\xD0\x99/g;    # 
  $cnt += $string =~ s/(?<!\xD0)\xE9/\xD1\x89/g;    # 
  $cnt += $string =~ s/(?<!\xD0)\x99/\xD0\xA9/g;    # 
  #=cut
  #  $cnt += $string =~ s/\xAB/"/g;                           # <
  #  $cnt += $string =~ s/\xBB/"/g;                           # >
  return wantarray ? ( $string, $cnt ) : $string;
}

sub cp_trans_hash {
  my ( $from, $to, $hash ) = @_;
  #  printlog('dev', 'cp_trans_hash:', $from, $to, $hash);
  return $hash if $from eq $to;
  $hash->{$_} = cp_trans( $from, $to, $hash->{$_} ) for keys %$hash;
  return wantarray ? %$hash : $hash;
}

sub max_hash_el {
  my ( $hash, $max, $ret ) = @_;
  $hash->{$_} > $max ? ( $max = $hash->{$_}, $ret = $_ ) : () for grep $_, keys %$hash;
  return $ret;
}

sub cp_dump {
  my ($data) = @_;
  printlog( 'devcp', "$_ = $data->{'stat'}{$_}" ) for keys %{ $data->{'stat'} };
}

sub detectcp {
  my ($string) = @_;
  my ( $detectedcp, $t );
  my %cpstat;
  for my $cp ( keys %{ $config{'trans_detect'} } ) { $$string =~ s/([$config{'trans_detect'}{$cp}])/++$cpstat{$cp},$1/eg; }
  $detectedcp = max_hash_el( \%cpstat, $config{'cp_detect_letters'} );
  return $detectedcp;
}

sub cp_detect_trans {
  my ( $string, $data, $cp_to, $cp_default, $prot, $host ) = @_;
  $cp_default ||= hconfig( 'cp_res', $host, $prot );
  $cp_to ||= hconfig( 'cp_db', $host );
  my $cnt;
  if ( hconfig( 'allow_cp_detect', $host ) and ( ++$data->{'tries'} < 20 or !$data->{'cp'} ) ) {
    $data->{'stat'}{ detectcp($string) }++;
    $data->{'cp'} = max_hash_el( $data->{'stat'}, hconfig( 'cp_detect_strings', $host ) );
    printlog( 'dbg', 'charset detected:', $data->{'cp'}, '   dbg: ', %{ $data->{'stat'} }, ' [', $$string, ']' )
      if $data->{'cp'} and $data->{'cp'} ne $cp_default;
  }
  if ( $data->{'cp'} and $data->{'cp'} ne $cp_to ) {
    ( $$string, $cnt ) = cp_trans( $data->{'cp'}, $cp_to, $$string );
    return $cnt ? $data->{'cp'} : undef;
  }
  if ($cp_default) {
    ( $$string, $cnt ) = cp_trans( $cp_default, $cp_to, $$string );
    return $cnt ? $cp_default : undef;
  }
}

sub cp_up {    #v1
  my ( $string, $cp ) = ( shift, cp_normalize( shift || 'cp1251' ) );
  eval "\$string =~ tr/$config{'trans_lo'}{$cp}/$config{'trans_up'}{$cp}/"
    if ( $config{'trans_up'}{$cp} and $config{'trans_lo'}{$cp} );
  return $string;
}

sub cp_lo {    #v1
  my ( $string, $cp ) = ( shift, cp_normalize( shift || 'cp1251' ) );
  eval "\$string =~ tr/$config{'trans_up'}{$cp}/$config{'trans_lo'}{$cp}/"
    if ( $config{'trans_up'}{$cp} and $config{'trans_lo'}{$cp} );
  return $string;
}

sub lang {
  my ( $key, $lang ) = shift, shift;
  #  print "CP[$config{'cp_config'},$work{'codepage'}]" if $key eq 'search';
  return
    #  "[".(%config)."]".
    shift() .    # "CP[$config{'cp_config'},$work{'codepage'}]".
    scalar cp_trans(
    $config{'cp_config'},
    $work{'codepage'}, (
      defined $config{'lng'}{ $lang ||= ( $work{'lang'} or $config{'lang'} ) }{$key}
      ? $config{'lng'}{$lang}{$key}
      : ( defined $config{'lng'}{''}{$key} ? $config{'lng'}{''}{$key} : $key )
    )
    ) . shift;
}

sub min {
  ( sort { $a <=> $b || $a cmp $b } @_ )[0];
}

sub max {
  ( sort { $b <=> $a || $b cmp $a } @_ )[0];
}

sub alarmed {
  my ( $timeout, $proc, @proc_param ) = @_;
  my $ret;
  eval {
    local $SIG{ALRM} = sub { die "alarm\n" }
      if $timeout;    # NB: \n required
    alarm $timeout if $timeout;
    $ret = $proc->(@proc_param) if ref $proc eq 'CODE';
    alarm 0 if $timeout;
  };
  if ( $timeout and $@ ) {
    printlog( 'err', 'Sorry, unknown error (',
      $@, ') runs:', ' [', join( ',', grep $_, map ( ( caller($_) )[2], ( 0 .. 15 ) ) ), ']' ),
      sleeper( 3600, 'alarmed' ), return
      unless $@ eq "alarm\n";    # propagate unexpected errors
    printlog( 'err', 'Sorry, timeout (', $timeout, ')' );
  } else {
    sleeper( undef, 'alarmed' );
  }    #    else { print "no timeout<br/>"; }
  return $ret;
}

sub mkdir_rec {
  my ( $name, $mask ) = @_;
  my $ret;
  $name =~ s|/+\s*$||;
  $name =~ s|\\|/|g;
  local @_ = ($name);
  push( @_, $name ) while $name =~ s|^(.+)/([^/]+)$|$1|;
  $ret += mkdir( $_, $mask ) for grep { !-d } reverse @_;
  return $ret;
}

sub check_int {
  my ( $int, $min, $max, $def ) = @_;
  #  printlog('dev', 'int', ( "int=$int,min=$min,max=$max,def=$def" ));
  $def = 0 unless defined $def;
  return $def unless ( defined($int) and length($int) );
  #  printlog('dev', "int0[$int]", defined $int, length($int));
  $int =~ s/\s+//g;
  $int = int($int);
  #  printlog('dev', 'int1',$int);
  return $def unless $int =~ /^-?\d+$/;
  #  printlog('dev', 'int2',$int, $min);
  return $min if defined $min and $int < $min;
  #  printlog('dev', 'int3',$int, $max);
  return $max if defined $max and $int > $max;
  #  printlog('dev', 'int4',$int);
  return $int;
}
{
  my $current_name;

  sub open_out_file {
    my ($name) = join( '.', grep ( /.+/, @_ ) );
    $name =~ s/\W+/_/g;
    close_out_file();
    $current_name = "$config{'datadir'}$config{'slash_sys'}$name.$config{'output'}";
    $work{'current_name_work'} = "$current_name$config{'work_ext'}";
    rename( $current_name, $work{'current_name_work'} ) if -e $current_name and $work{'current_name_work'} and $current_name;
    open( I, '>>', $work{'current_name_work'} )
      or printlog( 'err', "!!! UNABLE TO OPEN $work{'current_name_work'}" )
      and return;
  }

  sub close_out_file {
    if ( $work{'current_name_work'} ) {
      $processor{'out'}{'array'}->();
      print I";\n";
      close(I);
      rename( $work{'current_name_work'}, $current_name ) if $work{'current_name_work'} and $current_name;
    }
    $work{'current_name_work'} = $current_name = '';
  }
}

sub lib_init {
  $SIG{__WARN__} = sub {
    printlog( 'warn', $!, $@, @_ );
    printlog( 'die', 'caller', $_, caller($_) ) for ( 0 .. 15 );
  };
  $SIG{__DIE__} = sub {
    printlog( 'die', $!, $@, @_ );
    printlog( 'die', 'caller', $_, caller($_) ) for ( 0 .. 15 );
  };    #die $!;
  unless ( $static{'port2prot'} ) {
    @{ $static{'port2prot'} }{ ( $config{'scanner'}{$_}{'port'}, $_ ) } = ( $_, $_ ) for ( keys %{ $config{'scanner'} } );
  }
}
sub caller_trace { printlog( 'caller', $_, caller($_) ) for ( 0 .. $_[0] || 5 ); }

sub mysleep {
  if ( $_[0] > 1 and $config{'system'} eq 'win' ) {    #activeperl only?
    sleep(1) for ( 0 .. $_[0] );
  } else {
    sleep( $_[0] );
  }
}

sub sleeper {
  my ( $max, $where, $min, ) = @_;
  $where ||= join '', caller;
  ( $work{'sleeper'}{$where} ? printlog( 'dev', "sleeper: clean $where was $work{'sleeper'}{$where}" ) : () ),
    $work{'sleeper'}{$where} = 0, return 0
    if !$max
      or $ENV{'SERVER_PORT'};
  $min ||= 0.5;
  #  printlog( 'dbg', "sleepe0: sleep $where $work{'sleeper'}{$where} mi=$min" );
  ( $work{'sleeper'}{$where} ||= $min ) *= ( $work{'sleeper'}{$where} > $max ? 1 : 2 );
  printlog( 'dbg', "sleeper: sleep $where $work{'sleeper'}{$where}" );
  mysleep( $work{'sleeper'}{$where} );
  return $work{'sleeper'}{$where};
}

sub shuffle {
  my $deck = shift;
  $deck = [ $deck, @_ ] unless ref $deck eq 'ARRAY';
  my $i = @$deck;
  while ( $i-- ) {
    my $j = int rand( $i + 1 );
    @$deck[ $i, $j ] = @$deck[ $j, $i ];
  }
  return wantarray ? @$deck : $deck;
}

sub flush {
  #printlog('dev', 'FLUSH') ;
  return if $config{'no_flush'};
  select( ( select( $_[0] || *STDOUT ), $| = 1 )[0] );
}

sub paintdots_onreload {
  my ($ref) = shift;
  sub {
    if ( $_[0] =~ /[Ss]ubroutine (\w+) redefined/ ) {
      my ($subr) = $1;
      ++$$ref;
      local ($|) = 1;
      # $CPAN::Frontend->myprint(".($subr)");
      #     $CPAN::Frontend->myprint(".");
      print(".");
      return;
    }
    warn @_;
  };
}

sub config_read {
  #print "config_read($ENV{'SCRIPT_FILENAME'}, $_[0]);\n";
  #print ("config_read NOREAD!;\n");
  return if $static{'config_read'}{
        $ENV{'SCRIPT_FILENAME'}
          #  $ENV{'PROSEARCH_PATH'}
      }++ and !$_[0];
  #  print "  psmisc::config_read($_[0])";
  #  do $ENV{'PROSEARCH_PATH'} . './config.pl' or do '../config.pl';
  ( $ENV{'SCRIPT_FILENAME'} || $work{'$0'} || $0 ) =~ m|^(.+)[/\\].+?$|;
  $root_path =    #$ENV{'PROSEARCH_PATH'} ||
    ( $1 ? $1 . '/' : undef );
  #  $root_path||=  $1 . '/' if $1;
  $root_path =~ s|\\|/|g;
  #  do $ENV{'PROSEARCH_PATH'} . './config.pl' or
  #    print "pa=". ( $ENV{'SCRIPT_FILENAME'} ,';', $0),"\n";
  #print "config_read(); root_path = $root_path\n";
  my @errs;
  local $_ = do $root_path . 'config.pl';
  #    print( ' do1:',$_,',', $!, ' eval=', $@, "\n" ) if !$_ or $! or $@;
  push @errs, grep { $_ } $!, $@, $_ += do '../config.pl', push @errs, grep { $_ } $!, $@ unless $_;
  unless ($_) {
    print "Content-type: text/html\n\n" if defined( $ENV{'SERVER_PORT'} );
    print "config not found in $root_path" . "config.pl and ../config.pl\nReason:\n", join ";\n", @errs;
  }
  #  print"rp set1 to [$root_path]\n";
  conf(
    sub {
      #  print"rp set2 to [$root_path]\n";
      $config{'root_path'} = $root_path;
    },
    0.0001
  );
  #  print( ' do2:',$_,',', $!, ' eval=', $@, "\n" ) if $! or $@;
  #  print( ' do1:', $!, 'eval=', $@ ,"\n" ) if $! or $@;
  #  print( 'compile err1:', $!, "\n" ) if $!;
  #  print ('compile err2:',$@, "\n");
  #  require $ENV{'PROSEARCH_PATH'} . './config.pl' or do '../config.pl';
  #print('config_read',Dumper (\%config ));
  #print('config_read',(scalar keys %config ));
}

sub pre_calc_every {
  $config{'post_init_every'}{$_}->(@_)
    for grep { $config{'post_init_every'}{$_} } sort keys %{ $config{'post_init_every'} or {} };
}

sub pre_calc_once {
  #  $config{'post_init_once'}->(@_) if $config{'post_init_once'};
  #print "pre_calc_once\n";
  $config{'post_init_once'}{$_}->(@_)
    for grep { $config{'post_init_once'}{$_} } sort keys %{ $config{'post_init_once'} or {} };
}

sub pre_calc {
  pre_calc_once(@_);
  pre_calc_every(@_);
}

sub config_reload {
  #    print "psmisc::config_reload(clear=$_[0];; $config{'root_path'})";
  #   print "psmisc::config_reload(clear!=$_[0])\n";
  %config = () if $_[0];
  config_read( $_[1] );
  # print "read end;";
  $_[2]->() if ref $_[2] eq 'CODE';
  conf();
  #print ('compile err2:',$@, "\n");
  unless (%config) {
    print "Content-type: text/html\n\n" if defined( $ENV{'SERVER_PORT'} );
    print("Please fix error in config.pl: [$@]"), exit if $@;
    print "Please create config.pl with parametrs (see config.pl.dist) and correct modes [$!]";
    exit;
  }
  # print('config_reload',(scalar keys %config ));
  # print('config_reload',Dumper (\%config ));
}
sub config { &config_reload; }

sub reload_lib {
  %human = ();
  my $redef = 0;
  for my $file (@_) {
    printlog( 'dbg', "reloading $file: $INC{$file}" );
    open( my $fh, '<', ( $INC{$file} or $file ) ) or printlog( 'err', "reload err $file=$INC{$file}" ), next;
    local ($/);
    local ( $SIG{__WARN__} ) = paintdots_onreload( \$redef );
    local ( $SIG{__DIE__} )  = paintdots_onreload( \$redef );
    eval <$fh>;
    warn $@ if $@;
  }
}

sub conf {
  my ( $sub, $order ) = ( shift, shift );
  #  if ( !$ENV{'MOD_PERL'} ) {    $sub->(@_) if $sub;    return;  }
  my $id = $ENV{'SCRIPT_FILENAME'} || $work{'$0'} || $0;
  #   print join ' ',('dev',"conf($sub, $order, [$root_path] id=$id)", caller,"<br\n/>");
  unless ($sub) {
#        print("running", scalar keys %{ $static{'conf_init'}{ $ENV{'PROSEARCH_PATH'} } }, "now=",scalar keys %config, "\n");
#            print("RUNCONF[$id]($_/",scalar keys %{ $static{'conf_init'}{$id } },"] from(",join('|',@{$static{'conf_init_from'}{$id}{$_}}), ";", "<br\n/>"),
    $static{'conf_init'}{
      #    $ENV{'PROSEARCH_PATH'}
      #      $ENV{'SCRIPT_FILENAME'}
      $id
      }{$_}->() for sort { $a <=> $b } keys %{
      $static{'conf_init'}{
        #$ENV{'PROSEARCH_PATH'}
        #        $ENV{'SCRIPT_FILENAME'}
        $id
        }
      };
    #print("confrunned",  "now=",scalar keys %config, "\n");
    return;
  }
  local $_;
  $static{'conf_init'}{
    #    $ENV{'SCRIPT_FILENAME'}
    #$ENV{'PROSEARCH_PATH'}
    $id
    }{
    $_ = (
      $order or $static{'conf_count'}{
        #  $ENV{'PROSEARCH_PATH'}
        #      $ENV{'SCRIPT_FILENAME'}
        $id
        }
        += 10
    )
    }
    = $sub;
  $static{'conf_init_from'}{
    #$ENV{'SCRIPT_FILENAME'}
    $id
    }{$_} = [caller];
}

sub http_get {    # REWRITE easier
  my ( $what, $asfile, $lwpopt, $method, $content ) = @_;
  #printlog('dev', 'http_get',$what, $asfile);
  my %url = split_url($what);
  my $c = encode_url( $what, $config{'encode_url_file_mask'} );
  if ( length $c > 200 ) {
    my ( $bef, $mid, $aft ) = $c =~ /^(.{50})(.+)(.{50})$/;
    #    local $_ = 0;
    my $midv = 0;
    $midv += ord for split //, $mid;
    $c = join '__', $bef, $midv, $aft;
    #     $_ += ord;
    #    }
  }
  $c = ( $config{'cachedir'} or '.' ) . '/' . $c if ( $config{'cachedir'} );
  $c = $asfile if $asfile and $asfile != 1;
  #printlog('dev', $what, $asfile, "cache=$config{'cache_http'}, dir=$config{'cachedir'};");
  if ( $config{'cache_http'} and -e $c ) {
    return $c if $asfile;
    if ( open( CF, '<', $c ) ) {
      local $/;
      local $_ = <CF>;
      close(CF);
      return $_;
    }
  }
  eval {
    eval('use LWP::UserAgent; use URI::URL;1;') or printlog( 'err', 'http use libs', @!, $! );    #if not installed
    my $ua = LWP::UserAgent->new(
      'timeout' => hconfig( 'timeout', $url{'host'}, $url{'prot'} ),
      %{ $config{'lwp'} or {} }, %{ $lwpopt or {} }
    );
    #     $ua->proxy('http', 'http://proxy.ru:3128');
    if ( ref $config{'proxy'} eq 'ARRAY' ) {
      local @_ = @{ psmisc::shuffle( $config{'proxy'} )->[0] };
      #    psmisc::printlog('proxy', @_, Dumper($config{'proxy'}));
      $ua->proxy(@_);
    } elsif ( $config{'proxy'} ) {
      $ua->proxy( 'http', $config{'proxy'} );
    }
    $ua->mirror( $what, $c ), return $c if $asfile;
    $method ||= 'GET';
    #print "RwM:$method;";
    #    my $resp =( $method eq 'HEAD' ? $ua->head($what) :
    my $resp = (
      $ua->request(
        new HTTP::Request(
          $method,
          new URI::URL($what),
          new HTTP::Headers( 'User-Agent' => $config{'useragent'} || $config{'crawler_name'} ), $content
        )
      )
    );
    #print "[H:",$resp->header();
    #print "[H:",$resp->code();
    if ( $resp->is_success ) {
      if ( $config{'cachedir'} ) {
        open( CF, '>', $c ) or return;
        binmode(CF);
        print CF$resp->content;
        close(CF);
      }
      return $asfile ? $c : $resp->content;
    } else {
      printlog( 'dev', 'http getfail', $what, $resp->message );
      #      return $asfile ? undef: $resp->message;
      return undef;
    }
    1;
  } or printlog( 'err', @!, $! );
}

sub http_get_code {
  my ( $what, $lwpopt, $method ) = @_;
  #printlog('dev', 'http_get',$what, $asfile);
  eval {
    eval('use LWP::UserAgent; use URI::URL;1;') or printlog( 'err', 'http use libs', @!, $! );    #if not installed
    #    my $ua = ;
    #     $ua->proxy('http', 'http://proxy.ru:3128');
    my $resp = (
      ( LWP::UserAgent->new( 'timeout' => hconfig('timeout'), %{ $config{'lwp'} or {} }, %{ $lwpopt or {} } ) )->request(
        new HTTP::Request(
          ( $method or 'GET' ),
          new URI::URL($what),
          new HTTP::Headers( 'User-Agent' => $config{'crawler_name'} )
        )
      )
    );
    #print "[H:",$resp->header();
    return $resp->code();
  } or printlog( 'err', @!, $! );
}

sub loadlist {
  my %res = ();
  for my $sca (@_) {
    next unless $sca;
    open( SSF, '<', $sca ) or next;
    while (<SSF>) {
      next if /^\s*[#;]/;
      local @_ = split /\s+/, $_;
      my $host = shift or next;
      local %_;
      get_params_one( \%_, @_ );
      #      my ( $host, $tim ) = /^\s*(\S+)\s*(\S*)\s*/;
      #      next
      #        if !$host
      #        or ( $tim and ( $tim < time - hconfig( 'period', $host ) ) );
      #      $res{$host} = ( $tim or 1 );
      #printlog('dev', 'loadlist', $host, '=',\%_, '=', %_  );
      $res{$host} = \%_;
    }
    close(SSF);
  }
  #printlog('dev', 'loadlist-res:', \%res );
  return wantarray ? %res : \%res;
}
sub shelldata { s/[\x0d\x0a\"\'\`|><&]//g for @_; }    #`

=c
sub save_list {
 my ($file, $data) = @_;
 use Storable;
 store($data, $file);
=c
 return 1 unless open(SF, '>', $file);
 for my $str (sort keys %$data) {
    print SF join(' ', map{     encode_url($_) . (length($data->{$str}{$_}) ? ( '='. encode_url($data->{$str}{$_})) : ())} sort keys %{$data->{$str}}); 
#   for my $k (sort keys %{$data->{$str}}) {
 #  }
   print SF "\n";
 }
 
 close(SF);
}
=cut

{
  my ( $current, $order );

  sub program {
    my ( $name, $setorder ) = @_;
    return $current unless $name;
    $program{ $current = $name }{'order'} ||= ( $setorder or $order += ( $config{'order_step'} || 10 ) );
    #print "newprog($current, $program{$current}{'order'});" ;
    return $current;
  }    #v2
}
psmisc::program('params');
$program{ psmisc::program() }{'force'} = 1;
$program{ psmisc::program() }{'func'} ||= sub { $param = get_params(); };
psmisc::program('params_pre_config');
$program{ psmisc::program() }{'mask'}       ||= '^(-*c(onf)?-*)|(--).*';
$program{ psmisc::program() }{'param_name'} ||= 1;
$program{ psmisc::program() }{'func'}       ||= sub {
  my ( $v, $w ) = @_;
  $w =~ s/^(-*c(onf?)?-*)|(--)//i;
  $v =~ s/^NUL$//;
  return 0 unless defined($w) and defined($v);
#local @_ = split /__/, eval( '$config' . join( '', map { '{$_[' . $_ . ']}' } ( 0 .. $#_ ) ) . '= $param->{$_};' )  for ( grep { $param->{$_} } keys %$param );
  local @_ = split( /__/, $w ) or return 0;
  #  printlog( 'dev', 'genpre',$w, $v, @_);
  #  printlog( 'dev', 'gen', @_,'$config' . join( '', map { '{$_[' . $_ . ']}' } ( 0 .. $#_ ) ) . ' = $v;' );
  eval( '$config' . join( '', map { '{$_[' . $_ . ']}' } ( 0 .. $#_ ) ) . ' = $v;' );
  #for ( grep { $param->{$_} } keys %$param );
  #  $config{$w} = $v if defined($w) and defined($v);
  #printlog('dev', 'res', $config{'zzz'}{'yy'});
  return 0;
};
psmisc::program('config');
$program{ psmisc::program() }{'force'} = 1;
$program{ psmisc::program() }{'func'} ||= sub {
  psmisc::config_reload();    #$param
  psmisc::pre_calc($param);
  #  psmisc::config_init($param);
  return 0;
};
psmisc::program('params_config');
%{ $program{ psmisc::program() } } = ( %{ $program{'params_pre_config'} }, 'order' => $program{ psmisc::program() }{'order'} );
psmisc::program( 'help', 100000 );
$program{ psmisc::program() }{'mask'} ||= '^-*he?l?p?$';
$program{ psmisc::program() }{'func'} ||= sub {
  print "Usage: perl $work{'$0'} [action[=params]] [--config_key[=value]] [...] \n\n Actions:\n";
  for ( sort keys %program ) {
    next if $program{$_}{'force'} or /(_aft)|(_bef)$/;
    print "$_ $program{$_}{'desc'}\n";
  }
  print "\nConfig defaults:\n";
  for ( sort keys %config ) { print "--$_\t[$config{$_}]\n"; }
};

sub program_one {
  my $current = shift;
  return undef unless exists $program{$current};
  #  printlog('run', $current);
  #  print "program_one($current): ", sort( keys %$param ), "\n";
  if ( $program{$current}{'func'} and !$program{$current}{'disabled'} ) {
    my @ret;
    eval { @ret = $program{$current}{'func'}->(@_); };
    printlog( 'err', 'program', $current, 'run error:', $@ ) if $@;
    return wantarray ? @ret : $ret[0];
  }
  return undef;
}

sub program_run {
  #    our ($param) = @_;
  for my $n ( 0 .. 1 ) {
    #  print "program_run: ", sort( keys %$param ), "\n";
    my %masks;
    for my $current ( sort keys %program ) { ++$masks{ $program{$current}{'mask'} ||= "^-?$current\\d*\$" }; }
    $program{'default'}{'notmask'} = '^-?(' . join( '|', keys %masks ) . ")\\d*\$";
    for my $current ( grep { !$program{$_}{'checked'} } sort { $program{$a}{'order'} <=> $program{$b}{'order'} } keys %program )
    {
      #print "testc: $current", sort( keys %$param ), "\n";
      next if $current eq 'default' and !$n;
      ++$program{$current}{'checked'};
      #print "ke:", sort( keys %$param );
      for my $par ( sort( keys %$param ), grep { $program{$_}{'force'} } keys %program ) {
        #        printlog('dev', "test:$par");
        if (
          #BUG!!! next line always NOT on one char targets (/ z x ....)
          ( (
              !( $program{$current}{'notmask'} and $par =~ /$program{$current}{'notmask'}/i )
              and $par =~ /$program{$current}{'mask'}/i
            )
            or $program{$current}{'force'}
          )
          #  and $program{$current}{'func'}
          #  and !$program{$current}{'disabled'}
          and !$program{$current}{'runned'}
          )
        {
          state( 'program:', $current );
          #          print( 'dbg', 'program run', $current , "\n");
          #          printlog( 'dbg', 'program run', $current );
          #         local $_ = $program{$current}{'func'}->(
          local @_ = (
            ( defined( $param->{$par} ) and $param->{$par} ne '' ? $param->{$par} : () ),
            ( $program{$current}{'param_name'} ? $par : () )
          );
          program_one( $current . '_bef', @_ );
          local $_
            #eval {
            = program_one( $current, @_ );
#};
#printlog('err', 'program',$current,'run error:', $@) if $@;
#          local $_ = program_one($current,          (                        ( defined( $param->{$par} ) and $param->{$par} ne '' ? $param->{$par} : () ),            ( $program{$current}{'param_name'} ? $par : () )          ));
          program_one( $current . '_aft', @_ );
          printlog( 'warn', 'program finished', $current, '=', $_ ) if $_ and !ref $_;
          $program{$current}{'runned'} = 1 if $program{$current}{'once'} or $program{$current}{'force'};
          $program{$current}{'force'} = '';
        }
      }
    }
  }
}
#BEGIN { config_init(); }
config_init();
1;
